#!/usr/bin/perl

$squid_log="/var/log/squid/access.log";

my $direct_flag=1;
my %top_sites=();
my %top_sites_cnt=();

open (LOG, "<$squid_log") || die "Cant' open log $squid_log";
while(<LOG>){
    my ($s_time, $s_size, $s_ip, $s_type, $s_size2, $s_method, 
        $s_url, $s_hz, $s_proxy_status, $s_mime)=split(/\s+/);

    if ($direct_flag == 1 && $s_proxy_status !~ /^DIRECT/){
	next;
    }
    if ($direct_flag == 0 && $s_proxy_status =~ /^DIRECT/){
	next;
    }
    $s_url =~ /^.*\/([^\/]+)$/i;
    my $s_site = lc($1);
    $top_sites{$s_site} += $s_size;
    $top_sites_cnt{$s_site}++;
}
close(LOG);

    my $summ_size=0;
foreach my $cur_site (reverse sort { $top_sites{$a} <=> $top_sites{$b} } keys %top_sites){ 
    $summ_size += $top_sites{$cur_site};
    my $size = int($top_sites{$cur_site} / (1024*1024));
    if ($size <= 10){
	next;
    }
    print "$size Mb\t$cur_site\t$top_sites_cnt{$cur_site}\n";
}
my $size = int($summ_size / (1024*1024));

    print "\nALL: $size Mb\n";


